hdu 5115 Dire Wolf【区间dp】好题

Dire Wolf

Time Limit: 5000/5000 MS (Java/Others)    Memory Limit: 512000/512000 K (Java/Others)
Total Submission(s): 1827    Accepted Submission(s): 1046

Problem Description

Dire wolves, also known as Dark wolves, are extraordinarily large and powerful wolves. Many, if not all, Dire Wolves appear to originate from Draenor.
Dire wolves look like normal wolves, but these creatures are of nearly twice the size. These powerful beasts, 8 - 9 feet long and weighing 600 - 800 pounds, are the most well-known orc mounts. As tall as a man, these great wolves have long tusked jaws that look like they could snap an iron bar. They have burning red eyes. Dire wolves are mottled gray or black in color. Dire wolves thrive in the northern regions of Kalimdor and in Mulgore.
Dire wolves are efficient pack hunters that kill anything they catch. They prefer to attack in packs, surrounding and flanking a foe when they can.
— Wowpedia, Your wiki guide to the World of Warcra

Matt, an adventurer from the Eastern Kingdoms, meets a pack of dire wolves. There are N wolves standing in a row (numbered with 1 to N from left to right). Matt has to defeat all of them to survive.

Once Matt defeats a dire wolf, he will take some damage which is equal to the wolf’s current attack. As gregarious beasts, each dire wolf i can increase its adjacent wolves’ attack by bi. Thus, each dire wolf i’s current attack consists of two parts, its basic attack ai and the extra attack provided by the current adjacent wolves. The increase of attack is temporary. Once a wolf is defeated, its adjacent wolves will no longer get extra attack from it. However, these two wolves (if exist) will become adjacent to each other now.

For example, suppose there are 3 dire wolves standing in a row, whose basic attacks ai are (3, 5, 7), respectively. The extra attacks bi they can provide are (8, 2, 0). Thus, the current attacks of them are (5, 13, 9). If Matt defeats the second wolf first, he will get 13 points of damage and the alive wolves’ current attacks become (3, 15).

As an alert and resourceful adventurer, Matt can decide the order of the dire wolves he defeats. Therefore, he wants to know the least damage he has to take to defeat all the wolves.

Input

The first line contains only one integer T , which indicates the number of test cases. For each test case, the first line contains only one integer N (2 ≤ N ≤ 200).

The second line contains N integers ai (0 ≤ ai ≤ 100000), denoting the basic attack of each dire wolf.

The third line contains N integers bi (0 ≤ bi ≤ 50000), denoting the extra attack each dire wolf can provide.

Output

For each test case, output a single line “Case #x: y”, where x is the case number (starting from 1), y is the least damage Matt needs to take.

Sample Input

2

3

3 5 7

8 2 0

10

1 3 5 7 9 2 4 6 8 10

9 4 1 2 1 2 1 4 5 1

Sample Output

Case #1: 17

Case #2: 74

Hint

In the first sample, Matt defeats the dire wolves from left to right. He takes 5 + 5 + 7 = 17 points of damage which is the least damage he has to take.

Source

2014ACM/ICPC亚洲区北京站-重现赛(感谢北师和上交)

 

题目大意:

一共有n头狼,其中每只狼的初始攻击力为a【i】,其当前狼可以给其旁边挨着的狼的攻击力为b【i】,问将所有狼都弄死需要承受的最少的伤害;

分析第一组样例:

3 5 7

8 2 0

对应一头狼都没有杀死的时候这三头狼拥有的攻击力分别为:

5 13 9

如果我们弄死第一头狼,那么承受5点伤害,之后两头狼拥有的攻击力分别为:

5 9

然后我们再弄死当前第一头狼(原序列第二头狼),那么承受5点伤害,之后剩下一头狼的攻击力为7,那么其最小承受的伤害为5+5+7=17;

(如果我们现在弄死第二头狼,那么对应剩下的狼拥有的攻击力分别为:3 15)这里只是强调一下如果中间那头狼死了之后,第一头狼和第三头狼相当于挨着的。


思路:


1、首先看到两头狼可以合在一起,那么想到区间dp,设定dp【i】【j】表示从第i头狼到杀到第j头狼需要的最小花费。


2、那么不难想到状态转移方程:

(以下b【i】一定要在合法范围内再加和)

①if(len==0)dp【i】【i】=a【i】+b【i-1】+b【i+1】;

表示杀死一头狼的花费。

②else dp【i】【j】=min(dp【i+1】【j】+a【i】+b【i-1】+b【j+1】,dp【i】【j-1】+a【j】+b【i-1】+b【j+1】);

想要杀死从i到j的所有狼,我们可以通过杀死从i+1到第j头狼全部杀死之后再杀死第i头狼转移过来,也可以通过杀死从i到第j-1头狼全部杀死之后再杀死第j头狼转移过来。


3、状态转移方程不是很难想,这个题难点就难在区间合并上:

如图:如果我们想要合并从i到k的区间和从k+1到j的区间:


如果区间合并按照这样写:dp【i】【j】=min(dp【i】【j】,dp【i】【k】+dp【k+1】【j】),最终跑出来的数据是76,明显是不对的,那么为什么呢?

因为dp【i】【k】承受的伤害是包含b【i-1】+b【k+1】的,那么我们直接区间合并是不合法的。

那么我们要考虑这样一点:

第k头狼和第k+1头狼哪头狼先死的问题。

①如果第k头狼先死,那么当前情况合并之后的值为:dp【i】【k】+dp【k+1】【j】-b【k】+b【i-1】;

表示杀死第k+1头狼的时候没有收到第k头狼的攻击力辅助,而是收到了第i-1头狼的攻击力辅助;

②如果第k+1头狼先死,那么当前情况合并之后的值为:dp【i】【k】+dp【k+1】【j】-b【k+1】+b【j+1】;

表示杀死第k头狼的时候没有收到第k+1头狼的攻击力辅助,而是收到了第j+1头狼的攻击力辅助;

那么我们在区间合并的过程中,维护其最小值:dp【i】【j】=min(dp【i】【j】,min(dp【i】【k】+dp【k+1】【j】-b【k】+b【i-1】,dp【i】【k】+dp【k+1】【j】-b【k+1】+b【j+1】));


Ac代码:


#include<stdio.h>
#include<iostream>
#include<string.h>
using namespace std;
int dp[400][400];
int n;
int a[400];
int b[400];
int main()
{
    int t;
    int kase=0;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d",&n);
        for(int i=0;i<n;i++)
        {
            scanf("%d",&a[i]);
        }
        for(int j=0;j<n;j++)
        {
            scanf("%d",&b[j]);
        }
        memset(dp,0x3f3f3f3f,sizeof(dp));
        for(int len=0;len<=n;len++)
        {
            for(int i=0;i+len<n;i++)
            {
                int j=i+len;
                if(len==0)
                {
                    int zuo,you;
                    if(i-1>=0)zuo=b[i-1];
                    else zuo=0;
                    if(i+1<n)you=b[i+1];
                    else you=0;
                    dp[i][j]=a[i]+zuo+you;
                }
                else
                {
                    int zuo,you;
                    if(i-1>=0)zuo=b[i-1];
                    else zuo=0;
                    if(j+1<n)you=b[j+1];
                    else you=0;
                    dp[i][j]=min(dp[i+1][j]+zuo+you+a[i],dp[i][j-1]+zuo+you+a[j]);
                }
                for(int k=i;k<j;k++)
                {
                    int zuo,you;
                    if(i-1>=0)zuo=b[i-1];
                    else zuo=0;
                    if(j+1<n)you=b[j+1];
                    else you=0;
                    dp[i][j]=min(min(dp[i][k]-b[k+1]+dp[k+1][j]+you,dp[i][k]-b[k]+dp[k+1][j]+zuo),dp[i][j]);
                }
            }
        }
        printf("Case #%d: %d\n",++kase,dp[0][n-1]);
    }

}




  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值